/// <reference types="node" />
import "graphile-config";
import type { IncomingMessage, ServerResponse } from "http";
type PromiseOrDirect<T> = T | Promise<T>;
type DirectOrCallback<Request, T> = T | ((req: Request) => PromiseOrDirect<T>);
export interface V4GraphileBuildOptions {
    pgUseCustomNetworkScalars?: boolean;
}
export interface V4Options<Request extends IncomingMessage = IncomingMessage, Response extends ServerResponse = ServerResponse> {
    simpleCollections?: "both" | "only" | "omit";
    classicIds?: boolean;
    setofFunctionsContainNulls?: boolean;
    dynamicJson?: boolean;
    jwtPgTypeIdentifier?: string;
    jwtSecret?: string;
    disableDefaultMutations?: boolean;
    ignoreIndexes?: boolean;
    appendPlugins?: GraphileConfig.Plugin[];
    skipPlugins?: GraphileConfig.Plugin[];
    /** @deprecated Please use grafast.context 'pgSettings' key instead */
    pgSettings?: DirectOrCallback<Request | undefined, {
        [key: string]: string | undefined;
    }>;
    /** @deprecated Please use grafast.context callback instead */
    additionalGraphQLContextFromRequest?: (req: Request | undefined, res: Response | undefined) => Promise<Record<string, any>>;
    subscriptions?: boolean;
    ignoreRBAC?: boolean;
    graphileBuildOptions?: V4GraphileBuildOptions;
}
export declare const makeV4Preset: (options?: V4Options) => GraphileConfig.Preset;
export declare const V4Preset: GraphileConfig.Preset;
export default V4Preset;
//# sourceMappingURL=v4.d.ts.map